export const FilterMatchMode: {
    STARTS_WITH?: string,
    CONTAINS?: string,
    NOT_CONTAINS?: string,
    ENDS_WITH?: string,
    EQUALS?: string,
    NOT_EQUALS?: string,
    IN?: string,
    LESS_THAN?: string,
    LESS_THAN_OR_EQUAL_TO?: string,
    GREATER_THAN?: string,
    GREATER_THAN_OR_EQUAL_TO?: string,
    BETWEEN?: string,
    DATE_IS?: string,
    DATE_IS_NOT?: string,
    DATE_BEFORE?: string,
    DATE_AFTER?: string
}

export const FilterOperator: {
    AND?: string,
    OR?: string
}

interface FiltersOptions {
    startsWith?(value: any, filter: any, filterLocale: string): boolean,
    contains?(value: any, filter: any, filterLocale: string): boolean,
    notContains?(value: any, filter: any, filterLocale: string): boolean,
    endsWith?(value: any, filter: any, filterLocale: string): boolean,
    equals?(value: any, filter: any, filterLocale: string): boolean,
    notEquals?(value: any, filter: any, filterLocale: string): boolean,
    in?(value: any, filter: any): boolean,
    between?(value: any, filter: any): boolean,
    lt?(value: any, filter: any): boolean,
    lte?(value: any, filter: any): boolean,
    gt?(value: any, filter: any): boolean,
    gte?(value: any, filter: any): boolean,
    dateIs?(value: any, filter: any): boolean,
    dateIsNot?(value: any, filter: any): boolean,
    dateBefore?(value: any, filter: any): boolean,
    dateAfter?(value: any, filter: any): boolean
}

interface FilterServiceOptions {
    filter?(value: any[], fields: any[], filterValue: any, filterMatchMode: string, filterLocale: string): any[],
    filters?: FiltersOptions,
    register?(rule: string, fn: any): void
}

export const FilterService: FilterServiceOptions;

export const PrimeIcons: {
    ALIGN_CENTER?: string,
    ALIGN_JUSTIFY?: string,
    ALIGN_LEFT?: string,
    ALIGN_RIGHT?: string,
    AMAZON?: string,
    ANDROID?: string,
    ANGLE_DOUBLE_DOWN?: string,
    ANGLE_DOUBLE_LEFT?: string,
    ANGLE_DOUBLE_RIGHT?: string,
    ANGLE_DOUBLE_UP?: string,
    ANGLE_DOWN?: string,
    ANGLE_LEFT?: string,
    ANGLE_RIGHT?: string,
    ANGLE_UP?: string,
    APPLE?: string,
    ARROW_CIRCLE_DOWN?: string,
    ARROW_CIRCLE_LEFT?: string,
    ARROW_CIRCLE_RIGHT?: string,
    ARROW_CIRCLE_UP?: string,
    ARROW_DOWN?: string,
    ARROW_DOWN_LEFT?: string,
    ARROW_DOWN_RIGHT?: string,
    ARROW_LEFT?: string,
    ARROW_RIGHT?: string,
    ARROW_RIGHT_ARROW_LEFT?: string,
    ARROW_UP?: string,
    ARROW_UP_LEFT?: string,
    ARROW_UP_RIGHT?: string,
    ARROW_H?: string,
    ARROW_V?: string,
    ARROW_A?: string,
    AT?: string,
    BACKWARD?: string,
    BAN?: string,
    BARS?: string,
    BELL?: string,
    BITCOIN?: string,
    BOLT?: string,
    BOOK?: string,
    BOOKMARK?: string,
    BOOKMARK_FILL?: string,
    BOX?: string,
    BRIEFCASE?: string,
    BUILDING?: string,
    CALENDAR?: string,
    CALENDAR_MINUS?: string,
    CALENDAR_PLUS?: string,
    CALENDAR_TIMES?: string,
    CALCULATOR?: string,
    CAMERA?: string,
    CAR?: string,
    CARET_DOWN?: string,
    CARET_LEFT?: string,
    CARET_RIGHT?: string,
    CARET_UP?: string,
    CART_PLUS?: string,
    CHART_BAR?: string,
    CHART_LINE?: string,
    CHART_PIE?: string,
    CHECK?: string,
    CHECK_CIRCLE?: string,
    CHECK_SQUARE?: string,
    CHEVRON_CIRCLE_DOWN?: string,
    CHEVRON_CIRCLE_LEFT?: string,
    CHEVRON_CIRCLE_RIGHT?: string,
    CHEVRON_CIRCLE_UP?: string,
    CHEVRON_DOWN?: string,
    CHEVRON_LEFT?: string,
    CHEVRON_RIGHT?: string,
    CHEVRON_UP?: string,
    CIRCLE?: string,
    CIRCLE_FILL?: string,
    CLOCK?: string,
    CLONE?: string,
    CLOUD?: string,
    CLOUD_DOWNLOAD?: string,
    CLOUD_UPLOAD?: string,
    CODE?: string,
    COG?: string,
    COMMENT?: string,
    COMMENTS?: string,
    COMPASS?: string,
    COPY?: string,
    CREDIT_CARD?: string,
    DATABASE?: string,
    DELETELEFT?: string,
    DESKTOP?: string,
    DIRECTIONS?: string,
    DIRECTIONS_ALT?: string,
    DISCORD?: string,
    DOLLAR?: string,
    DOWNLOAD?: string,
    EJECT?: string,
    ELLIPSIS_H?: string,
    ELLIPSIS_V?: string,
    ENVELOPE?: string,
    ERASER?: string,
    EURO?: string,
    EXCLAMATION_CIRCLE?: string,
    EXCLAMATION_TRIANGLE?: string,
    EXTERNAL_LINK?: string,
    EYE?: string,
    EYE_SLASH?: string,
    FACEBOOK?: string,
    FAST_BACKWARD?: string,
    FAST_FORWARD?: string,
    FILE?: string,
    FILE_EDIT?: string,
    FILE_EXCEL?: string,
    FILE_EXPORT?: string,
    FILE_IMPORT?: string,
    FILE_PDF?: string,
    FILE_WORD?: string,
    FILTER?: string,
    FILTER_FILL?: string,
    FILTER_SLASH?: string,
    FLAG?: string,
    FLAG_FILL?: string,
    FOLDER?: string,
    FOLDER_OPEN?: string,
    FORWARD?: string,
    GIFT?: string,
    GITHUB?: string,
    GLOBE?: string,
    GOOGLE?: string,
    HASHTAG?: string,
    HEART?: string,
    HEART_FILL?: string,
    HISTORY?: string,
    HOURGLASS?: string,
    HOME?: string,
    ID_CARD?: string,
    IMAGE?: string,
    IMAGES?: string,
    INBOX?: string,
    INFO?: string,
    INFO_CIRCLE?: string,
    INSTAGRAM?: string,
    KEY?: string,
    LANGUAGE?: string,
    LINK?: string,
    LINKEDIN?: string,
    LIST?: string,
    LOCK?: string,
    LOCK_OPEN?: string,
    MAP?: string,
    MAP_MARKER?: string,
    MEGAPHONE?: string,
    MICREPHONE?: string,
    MICROSOFT?: string,
    MINUS?: string,
    MINUS_CIRCLE?: string,
    MOBILE?: string,
    MONEY_BILL?: string,
    MOON?: string,
    PALETTE?: string,
    PAPERCLIP?: string,
    PAUSE?: string,
    PAYPAL?: string,
    PENCIL?: string,
    PERCENTAGE?: string,
    PHONE?: string,
    PLAY?: string,
    PLUS?: string,
    PLUS_CIRCLE?: string,
    POUND?: string,
    POWER_OFF?: string,
    PRIME?: string,
    PRINT?: string,
    QRCODE?: string,
    QUESTION?: string,
    QUESTION_CIRCLE?: string,
    REDDIT?: string,
    REFRESH?: string,
    REPLAY?: string,
    REPLY?: string,
    SAVE?: string,
    SEARCH?: string,
    SEARCH_MINUS?: string,
    SEARCH_PLUS?: string,
    SEND?: string,
    SERVER?: string,
    SHARE_ALT?: string,
    SHIELD?: string,
    SHOPPING_BAG?: string,
    SHOPPING_CART?: string,
    SIGN_IN?: string,
    SIGN_OUT?: string,
    SITEMAP?: string,
    SLACK?: string,
    SLIDERS_H?: string,
    SLIDERS_V?: string,
    SORT?: string,
    SORT_ALPHA_DOWN?: string,
    SORT_ALPHA_ALT_DOWN?: string,
    SORT_ALPHA_UP?: string,
    SORT_ALPHA_ALT_UP?: string,
    SORT_ALT?: string,
    SORT_ALT_SLASH?: string,
    SORT_AMOUNT_DOWN?: string,
    SORT_AMOUNT_DOWN_ALT?: string,
    SORT_AMOUNT_UP?: string,
    SORT_AMOUNT_UP_ALT?: string,
    SORT_DOWN?: string,
    SORT_NUMERIC_DOWN?: string, 
    SORT_NUMERIC_ALT_DOWN?: string,
    SORT_NUMERIC_UP?: string,
    SORT_NUMERIC_ALT_UP?: string,
    SORT_UP?: string,
    SPINNER?: string,
    STAR?: string,
    STAR_FILL?: string,
    STEP_BACKWARD?: string,
    STEP_BACKWARD_ALT?: string,
    STEP_FORWARD?: string,
    STEP_FORWARD_ALT?: string,
    STOP?: string,
    STOPWATCH?: string,
    STOP_CIRCLE?: string,
    SUN?: string,
    SYNC?: string,
    TABLE?: string,
    TABLET?: string,
    TAG?: string,
    TAGS?: string,
    TELEGRAM?: string,
    TH_LARGE?: string,
    THUMBS_DOWN?: string,
    THUMBS_DOWN_FILL?: string,
    THUMBS_UP?: string,
    THUMBS_UP_FILL?: string,
    TICKET?: string,
    TIMES?: string,
    TIMES_CIRCLE?: string,
    TRASH?: string,
    TRUCK?: string,
    TWITTER?: string,
    UNDO?: string,
    UNLOCK?: string,
    UPLOAD?: string,
    USER?: string,
    USER_EDIT?: string,
    USER_MINUS?: string,
    USER_PLUS?: string,
    USERS?: string,
    VERIFIED?: string,
    VIDEO?: string,
    VIMEO?: string,
    VOLUME_DOWN?: string,
    VOLUME_OFF?: string,
    VOLUME_UP?: string,
    WALLET?: string,
    WHATSAPP?: string,
    WIFI?: string,
    WINDOW_MAXIMIZE?: string,
    WINDOW_MINIMIZE?: string,
    WRENCH?: string,
    YOUTUBE?: string
}

export const ToastSeverity: {
    INFO?: string,
    WARN?: string,
    ERROR?: string,
    SUCCESS?: string
}